version: "3.7"

services:
  traefik:
    image: traefik:{{traefik_image_tag}}
    container_name: traefik
    restart: always
    command: --configfile traefik.yml
{% if traefik_add_dnsresolver %}
    environment:
{% if dns_resolver == 'route53' %}
      - AWS_ACCESS_KEY_ID={{r53_aws_access_key_id}}
      - AWS_SECRET_ACCESS_KEY={{r53_aws_secret_access_key}}
      - AWS_HOSTED_ZONE_ID={{r53_aws_hosted_zone_id}}
{% endif %}
{% if dns_resolver == 'cloudflare' %}      
      - CF_API_EMAIL={{cf_api_email}}
      - CF_DNS_API_TOKEN={{cf_api_key}}
{% endif %}
{% endif %}
    labels:
      - traefik.enable=true
      # https
      - traefik.http.routers.traefik.rule=Host(`{{traefik_sub_domain}}{{domain}}`)
      - traefik.http.routers.traefik.tls=true
      - traefik.http.routers.traefik.tls.certresolver={{traefik_resolver}}
      - traefik.http.routers.traefik.entrypoints=websecure
      - traefik.http.routers.traefik.tls.options=default
{% if traefik_basic_auth != '' %}
      - traefik.http.routers.traefik.middlewares=https-redirect@file,security-headers@file,traefik-auth@docker
{% else %}
      - traefik.http.routers.traefik.middlewares=https-redirect@file,security-headers@file
{% endif %}
      - traefik.http.routers.traefik.service=traefik
      - traefik.http.services.traefik.loadbalancer.server.port=8080
      # http
      - traefik.http.routers.traefik-insecure.rule=Host(`{{traefik_sub_domain}}{{domain}}`)
      - traefik.http.routers.traefik-insecure.middlewares=https-redirect@file,security-headers@file
      - traefik.http.routers.traefik-insecure.entrypoints=web
      - traefik.http.routers.traefik-insecure.service=traefik
{% if traefik_basic_auth != '' %}
      - traefik.http.middlewares.traefik-auth.basicauth.users={{traefik_basic_auth}}
{% endif %}
    ports:
      - "80:80"
      - "443:443"
    networks:
      - traefiknet
    volumes:
      - "./traefik.yml:/etc/traefik/traefik.yml"
      - "./dynamic_conf.yml:/etc/traefik/dynamic_conf.yml"
      - "./letsencrypt:/letsencrypt:rw"
      - "/var/run/docker.sock:/var/run/docker.sock:ro"

{% if portainer %}
  portainer:
    image: portainer/portainer-ce:{{portainer_image_tag}}
    container_name: portainer
    restart: always
{% if portainer_default_admin != '' %}
    command: --admin-password '{{portainer_default_admin}}'
{% endif %}
    labels:
      - traefik.enable=true
      - traefik.http.routers.portainer.rule=Host(`{{portainer_sub_domain}}{{domain}}`)
      - traefik.http.routers.portainer.tls=true
      - traefik.http.routers.portainer.tls.certresolver={{portainer_resolver}}
      - traefik.http.routers.portainer.entrypoints=websecure
      - traefik.http.routers.portainer.tls.options=default
      - traefik.http.routers.portainer.middlewares=https-redirect@file,security-headers@file
      - traefik.http.routers.portainer-insecure.rule=Host(`{{portainer_sub_domain}}{{domain}}`)
      - traefik.http.routers.portainer-insecure.middlewares=https-redirect@file,security-headers@file
      - traefik.http.routers.portainer-insecure.entrypoints=web
      - traefik.http.services.portainer.loadbalancer.server.port=9000
      - traefik.http.routers.portainer.service=portainer
      - traefik.http.routers.portainer-insecure.service=portainer
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock
      - ./portainer_data:/data
    networks:
      - traefiknet
{% endif %}


networks:
  traefiknet:
    name: {{traefik_network}}
